/******************************************************************

"Copyright  1994 by the Massachusetts  Institute  of  Technology.  All
rights reserved.

Developed by John Y. A. Wang at the  Media Laboratory, MIT, Cambridge,
Massachusetts, with  support  from Secom Ltd., Goldstar Ltd.,  and the
Television of Tomorrow Program.

For use by authorized users only.

This distribution is approved  by Nicholas Negroponte, Director of the
Media Laboratory, MIT.

Permission to use, copy, or modify this software and its documentation
for educational and research purposes only and without  fee is  hereby
granted, provided that this copyright notice and the original authors'
names  appear  on  all  copies  and   supporting   documentation.   If
individual  files  are  separated  from  this  distribution  directory
structure, this copyright notice must be included.  For any other uses
of  this software, in  original or  modified form, including  but  not
limited to distribution in whole or in part, specific prior permission
must be  obtained  from  MIT.   These  programs  shall  not  be  used,
rewritten,  or  adapted  as  the  basis  of a  commercial software  or
hardware  product without  first  obtaining  appropriate licenses from
MIT.  MIT.  makes no  representations about  the  suitability of  this
software for any purpose.  It is  provided "as is" without  express or
implied warranty.

******************************************************************/


/***************************************************************
*** File: byteops.c
*** Author: John Y. A. Wang
*** Date: January 15, 1993
*** Copyright 1993, Massachusetts Institute of Technology, All Rights Reserved.
***
*** Description: byte image operations
***************************************************************/

static  char *copyright="\
\n\n***********************************************\n\
File: byteops.c\n\
Author: John Y. A. Wang.\n\
The MIT Media Lab.\n\
Copyright (c) 1993, All Rights Reserved.\n\
***********************************************\n\n";

#include "motion.h"

/*
  cc -O4 -fsingle -c byteops.c 

  lint byteops.c
*/

/*************************************/
/* fill a byte array with val */
void fill_byte(array,val,asize)
  unsigned char *array;
  unsigned char val;
  int asize;
{
  int i;
  for(i=0;i<asize;i++)
    array[i]=val;
}

/***************************************/
/* crop a byte 2D array. Note: when res==im, funny things will happen */
void crop_byte(im,xdim,ydim,xstart,ystart,res,rxdim,rydim)
  unsigned char *im, *res;
  int xstart,ystart,xdim,ydim,rxdim,rydim;
{
  int x,y;
  int rxend=rxdim,ryend=rydim; /* not inclusive */
  int rxstart=0, rystart=0;
  int rypos,iypos;
  int cpysize;

  if(xstart<0) { rxstart= -xstart; xstart=0;}
  if((xstart+rxdim)>xdim) {rxend=xdim-xstart;} 
  if(ystart<0) { rystart= -ystart; ystart=0;}
  if((ystart+rydim)>ydim) {ryend=ydim-ystart;} 
  
  for(x=0,y=rxdim*rydim;x<y;res[x]=(float)0.0,x++);

  cpysize=sizeof(unsigned char)*(rxend-rxstart);

  for(y=rystart,iypos=ystart*xdim+xstart,rypos=rystart*rxdim+rxstart; y<ryend ;
      y++,iypos+=xdim,rypos+=rxdim) {
    memcpy(res+rypos,im+iypos,cpysize);
  }
}
