/******************************************************************

"Copyright  1994 by the Massachusetts  Institute  of  Technology.  All
rights reserved.

Developed by John Y. A. Wang at the  Media Laboratory, MIT, Cambridge,
Massachusetts, with  support  from Secom Ltd., Goldstar Ltd.,  and the
Television of Tomorrow Program.

For use by authorized users only.

This distribution is approved  by Nicholas Negroponte, Director of the
Media Laboratory, MIT.

Permission to use, copy, or modify this software and its documentation
for educational and research purposes only and without  fee is  hereby
granted, provided that this copyright notice and the original authors'
names  appear  on  all  copies  and   supporting   documentation.   If
individual  files  are  separated  from  this  distribution  directory
structure, this copyright notice must be included.  For any other uses
of  this software, in  original or  modified form, including  but  not
limited to distribution in whole or in part, specific prior permission
must be  obtained  from  MIT.   These  programs  shall  not  be  used,
rewritten,  or  adapted  as  the  basis  of a  commercial software  or
hardware  product without  first  obtaining  appropriate licenses from
MIT.  MIT.  makes no  representations about  the  suitability of  this
software for any purpose.  It is  provided "as is" without  express or
implied warranty.

******************************************************************/


/***************************************************************
*** File: default-analysis.c
*** Author: John Y. A. Wang
*** Date: January 15, 1993
*** Copyright 1993, Massachusetts Institute of Technology, All Rights Reserved.
***
*** Description: set the defaults for structures and options
***************************************************************/

/*****************************************************************/
#include "dynamo.h"
/*****************************************************************/

static  char *copyright="\
\n\n***********************************************\n\
Developed by John Y. A. Wang at the Media Laboratory, MIT, Cambridge,Massachusetts\n\
Copyright  1993 by the Massachusetts  Institute  of  Technology.  All rights reserved.\n\
***********************************************\n\n";

set_default_affine(an)
  Affine_Analysis *an;
{
  int i;
  
  /************************ defaults for analysis **********/
  for(i=0;i<6;an->param_init[i]=0.0,i++);   /* init param_init to 0.0 */
  for(i=0;i<6;an->factor[i]=1.0,i++);        /* init fmask to 1.0 */
  for(i=0;i<10;an->method[i]=1.0,i++);  /* init method to 1.0 */
  an->level=2;  an->tstep=1;
  an->xstart=0; an->ystart=0; an->xend=(int)9999; an->yend=(int)9999;
  an->start=(int)0; an->end=(int)0;
}

/******** set default optical flow estimation settings *************/
void set_default_optical(an)
  Optical_Analysis *an;
{
  int i;

  /************************ defaults for optical flow analysis **********/
  an->level=(int)2; an->blur=(int)1; an->tstep=(int)1;
  an->start=(int)0; an->end=(int)0;
  for(i=0;i<10;an->method[i]=(float)1.0,i++);  /* init method to 1.0 */
  an->noise=(float)1.0; an->xbias=(float)1.0; an->ybias=(float)1.0;
  an->clipmin=(float)-5.0; an->clipmax=(float)5.0;
  an->sfdim=(int)5;  binomial_filter(an->sum_filt,an->sfdim);
  an->pfdim=(int)5;  binomial_filter(an->pyr_filt,an->pfdim);
  an->expfdim=(int)5;  binomial_filter(an->exp_filt,an->expfdim);
  an->stat=(int)0;
}
