/******************************************************************

"Copyright  1994 by the Massachusetts  Institute  of  Technology.  All
rights reserved.

Developed by John Y. A. Wang at the  Media Laboratory, MIT, Cambridge,
Massachusetts, with  support  from Secom Ltd., Goldstar Ltd.,  and the
Television of Tomorrow Program.

For use by authorized users only.

This distribution is approved  by Nicholas Negroponte, Director of the
Media Laboratory, MIT.

Permission to use, copy, or modify this software and its documentation
for educational and research purposes only and without  fee is  hereby
granted, provided that this copyright notice and the original authors'
names  appear  on  all  copies  and   supporting   documentation.   If
individual  files  are  separated  from  this  distribution  directory
structure, this copyright notice must be included.  For any other uses
of  this software, in  original or  modified form, including  but  not
limited to distribution in whole or in part, specific prior permission
must be  obtained  from  MIT.   These  programs  shall  not  be  used,
rewritten,  or  adapted  as  the  basis  of a  commercial software  or
hardware  product without  first  obtaining  appropriate licenses from
MIT.  MIT.  makes no  representations about  the  suitability of  this
software for any purpose.  It is  provided "as is" without  express or
implied warranty.

******************************************************************/


/***************************************************************
*** File: display-menu.c
*** Author: John Y. A. Wang
*** Date: January 15, 1993
*** Copyright 1993, Massachusetts Institute of Technology, All Rights Reserved.
***
*** Description: display menus.
***************************************************************/

/*****************************************************************/
#include "dynamo.h"
/*****************************************************************/

/********** IMPORTANT:  put copyright label in all the files ***********/
static  char *copyright="\
\n\n***********************************************\n\
Developed by John Y. A. Wang at the Media Laboratory, MIT, Cambridge,Massachusetts\n\
Copyright  1993 by the Massachusetts  Institute  of  Technology.  All rights reserved.\n\
***********************************************\n\n";

/*
  cc -O4 -fsingle -c display-menu.c 
  SUN:  cc -O4 -fsingle -c display-menu.c

  lint display-menu.c
*/
/*****************************************************************/

/*****************************************************************/
display_main_menu()
{
  printf("\n\t-----------------------------------------------\n");
  printf("\t\tMAIN MENU\n");
  printf("\t%d) Image Management\n",MAIN_IMAGE_MANAGEMENT_MENU_OPT);
  printf("\t%d) Affine Motion Analysis\n",MAIN_AFFINE_ANALYSIS_OPT);
  printf("\t%d) Optic Flow Motion Analysis\n",MAIN_OPTICAL_FLOW_ANALYSIS_OPT);
  printf("\t%d) Display Images\n",MAIN_DISPLAY_IMAGES_OPT);
  printf("\t%d) Enhance Image by Motion Compensation\n",MAIN_ENHANCE_IMAGES_OPT);
  printf("\t%d) Image Binary Operations\n",MAIN_BINARY_OPERATION_OPT);
  printf("\t%d) Image Unary Operations\n",MAIN_UNARY_OPERATION_OPT);
  printf("\t%d) Frame Rate Conversion Using Optic Flow\n",MAIN_FRAME_RATE_CONV_OPT);

  printf("\n\t%d) QUIT \n", MAIN_QUIT_OPT);
  printf("\n");
  fflush(stdout);
}

/*****************************************************************/
/*****************************************************************/
display_image_management_menu()
{
  printf("\n\t-----------------------------------------------\n");
  printf("\t\tIMAGE MANAGEMENT MENU\n");
  printf("\t%d) Load Image Sequence\n",IMAGE_LOAD_OPT);
  printf("\t%d) Change Image Sequence Cache Size\n",IMAGE_CHANGE_CACHE_SIZE_OPT);
  printf("\t%d) Memory Status\n", IMAGE_STATUS_OPT);
  printf("\t%d) Remove Image Sequence\n",IMAGE_DELETE_OPT);
  printf("\t%d) Save Image Sequence\n",IMAGE_SAVE_OPT);
  printf("\n\t%d) Reset Memory!!\n",IMAGE_RESET_MEMORY_OPT);
/*  printf("\t%d) Pop to Previous Menu\n",IMAGE_SAVE_OPT); */
  printf("\n");
  fflush(stdout);
}

/*****************************************************************/
/*****************************************************************/
display_affine_analysis_menu()
{
  printf("\n\t-----------------------------------------------\n");
  printf("\t\tAFFINE ANALYSIS MENU\n");
  printf("\t%d) Display Analysis Settings\n", AFFINE_DISPLAY_ANALYSIS_OPT);
  printf("\t%d) Run Global Affine Analysis \n", AFFINE_RUN_ANALYSIS_OPT);
  printf("\t%d) Display Analysis Results\n", AFFINE_DISPLAY_PARAMS_OPT);
  printf("\t%d) Save Analysis Results\n", AFFINE_SAVE_PARAMS_OPT);
  printf("\t%d) Load Affine Parameters from File\n", AFFINE_LOAD_PARAMS_OPT);
  printf("\t%d) Affine Align Images\n", AFFINE_ALIGN_IMAGES_OPT);
  printf("\n");
  fflush(stdout);
}

/*****************************************************************/
/*****************************************************************/
display_optical_flow_analysis_menu()
{
  printf("\n\t-----------------------------------------------\n");
  printf("\t\tOPTIC FLOW ANALYSIS MENU\n");
  printf("\t%d) Run Optic Flow Analysis \n",OPTICAL_FLOW_RUN_ANALYSIS_OPT);
  printf("\t%d) Display Analysis Settings\n",OPTICAL_FLOW_DISPLAY_OPT);
  printf("\t%d) Display Optic Flow Fields\n",OPTICAL_FLOW_DISPLAY_FIELD_OPT);
  printf("\n");
  fflush(stdout);
}

/*****************************************************************/
/*****************************************************************/
display_display_images_menu()
{
  printf("\n\t-----------------------------------------------\n");
  printf("\t\tDISPLAY IMAGES MENU\n");
  printf("\t%d) Display Original Images\n",DISPLAY_ORIGINAL_OPT);
  printf("\t%d) Display Affine_Aligned Images\n",DISPLAY_AFFINE_ALIGN_OPT);
  printf("\n");
}

/*****************************************************************/
/*****************************************************************/
display_enhance_images_menu()
{
  printf("\n\t-----------------------------------------------\n");
  printf("\t\tENHANCE IMAGE BY MOTION COMPENSATION MENU\n");
  printf("\t%d) Temporal Median Enhancement\n",ENHANCE_MEDIAN_ALIGN_OPT);
  printf("\t%d) Temporal Average Enhancemnt\n",ENHANCE_AVERAGE_ALIGN_OPT);
  printf("\n");
}

/*****************************************************************/
/*****************************************************************/
display_binary_ops_menu()
{
  printf("\n\t-----------------------------------------------\n");
  printf("\t\tIMAGE BINARY OPERATIONS MENU\n");
  printf("\t%d) Add Images\n",BIN_ADD_OPT);
  printf("\t%d) Subtract Images\n",BIN_SUB_OPT);
  printf("\t%d) Multiply Images\n",BIN_MUL_OPT);
  printf("\t%d) Divide Images\n",BIN_SUB_OPT);
  printf("\n");
}
/*****************************************************************/
/*****************************************************************/
display_unary_ops_menu()
{
  printf("\n\t-----------------------------------------------\n");
  printf("\t\tIMAGE UNARY OPERATIONS MENU\n");
  printf("\t%d) Temporal Median Image Sequence\n",UNI_MEDIAN_OPT);
  printf("\t%d) Temporal Average Image Sequence\n",UNI_AVERAGE_OPT);
  printf("\n");
}
