/******************************************************************

"Copyright  1994 by the Massachusetts  Institute  of  Technology.  All
rights reserved.

Developed by John Y. A. Wang at the  Media Laboratory, MIT, Cambridge,
Massachusetts, with  support  from Secom Ltd., Goldstar Ltd.,  and the
Television of Tomorrow Program.

For use by authorized users only.

This distribution is approved  by Nicholas Negroponte, Director of the
Media Laboratory, MIT.

Permission to use, copy, or modify this software and its documentation
for educational and research purposes only and without  fee is  hereby
granted, provided that this copyright notice and the original authors'
names  appear  on  all  copies  and   supporting   documentation.   If
individual  files  are  separated  from  this  distribution  directory
structure, this copyright notice must be included.  For any other uses
of  this software, in  original or  modified form, including  but  not
limited to distribution in whole or in part, specific prior permission
must be  obtained  from  MIT.   These  programs  shall  not  be  used,
rewritten,  or  adapted  as  the  basis  of a  commercial software  or
hardware  product without  first  obtaining  appropriate licenses from
MIT.  MIT.  makes no  representations about  the  suitability of  this
software for any purpose.  It is  provided "as is" without  express or
implied warranty.

******************************************************************/


/***************************************************************
*** File: frame-rate-conv.c
*** Author: John Y. A. Wang
*** Date: February 8, 1993
*** Modified:  Ujjaval Desai
*** Modified: jyawang 2/25/94
*** Copyright 1994, Massachusetts Institute of Technology, All Rights Reserved.
***
*** Description: frame rate conversion using optic flow
***************************************************************/
/*****************************************************************/
static  char *copyright="\
\n\n***********************************************\n\
Developed by John Y. A. Wang at the Media Laboratory, MIT, Cambridge,Massachusetts\n\
Copyright  1993 by the Massachusetts  Institute  of  Technology.  All rights reserved.\n\
***********************************************\n\n";
/*****************************************************************/
#include "dynamo.h"

#define F_RATE_RET(rc)  { \
        free_images(malloc_images,nmalloc); \
     	{if(flowpid!=NULL) {Close_Screen(flowpid);}}; \
			     return(rc);}


#define FDIM 5   /* default filter dimensions */

FILE *OpenMultiChScreen();

/***************************************************************/
frame_rate_conv(image_mgr)
  Image_Manager *image_mgr;
{
  float *im2=NULL,*temp=NULL; 
  float *im1=NULL,*xflow=NULL,*yflow=NULL, *im_offset=NULL,*ttemp=NULL; 
  int ttempsize=0;

  Frame_Rate_Conv *an;
  Optical_Analysis *an1;
  Image_Cache *cache;
/*  int i,j; */
  char *title=image_mgr->cbuf1;
  extern char *args;
  char *yn=image_mgr->yn;
  int imsize,num,counter=0;

  Image_Cache *cache_xflow, *cache_yflow, *cache_interp;

  int nmalloc=0;
  char *malloc_images[10];

  int length=0;
  int xdim= -1, ydim= -1;
  float gamma=0.5;
  int start=0,end=1000;
  float toffset=0;
  unsigned char *array;
  FILE *flowpid=NULL;
  float time,time_step=1;
  int cur_flow_frame;
  float xscale=-1,yscale=-1,fxscale,fyscale,interp;
  float *res=NULL,*count=NULL;
  
  float xfilt[10],yfilt[10],filt[100];
/*  char* xfiltstr=NULL, *yfiltstr=NULL, *filtstr=NULL; */
  int xfdim=-1,yfdim=-1;
/*  float xvar=.02,yvar=.02; */

  int nchannels=1,channel,cf,cimsize=0,imethod=0;

/*  int dbg=0; */

  int trunc=0;

  /**************** Analysis *******************************/
  printf("Performing frame rate conversion with the following options:\n");

  if((cache=ask_name_get_cache(image_mgr))==NULL)
    return(0);

  imsize=cache->imsize;
  ttempsize=10*imsize;
  an= &(cache->frame_rate_conv);
  an1= &(cache->optical_analysis);
  start = (int)an1->start;
  end = (int)(an1->end);
  an->time_step = (float)1;
  printf("\tConversion ratio: (%f) : ",an->time_step);
  readline(args,ARGSIZE,stdin);
  if(strlen(args)!=0) sscanf(args,"%f",&an->time_step);
  
  if(an->time_step ==  0) {
    printf("Conversion Ratio out of range. ( ratio > 0)");
    return(0);
  }

  if(an->time_step < 0) {  /* just pad with regular frames */
    trunc=1; an->time_step = -an->time_step;  }
  else { trunc=0; } /* interpolate */

  an->yscale = (float)1;
/*
  printf("\tyscale: (%f) : ",an->yscale);
  readline(args,ARGSIZE,stdin);
  if(strlen(args)!=0) sscanf(args,"%f",&an->yscale);
*/ 

  an->xscale = (float)1;
/*
  printf("\txscale: (%f) : ",an->xscale);
  readline(args,ARGSIZE,stdin);
  if(strlen(args)!=0) sscanf(args,"%f",&an->xscale);
*/

  an->xvar = (float)0.013;
/*
  printf("\txvar: (%f) : ",an->xvar);
  readline(args,ARGSIZE,stdin);
  if(strlen(args)!=0) sscanf(args,"%f",&an->xvar);
*/

  an->yvar = (float)0.013;
/*
  printf("\tyvar: (%f) : ",an->yvar);
  readline(args,ARGSIZE,stdin);
  if(strlen(args)!=0) sscanf(args,"%f",&an->yvar);
*/

  gamma = (float)0.5;
  printf("\tgamma: (%f) : ",cache->gamma);
  readline(args,ARGSIZE,stdin);
  if(strlen(args)!=0) sscanf(args,"%f",&gamma);

/*****************************************************************/
/*******************************************************************/
  if(xfdim<0) xfdim=FDIM; if(yfdim<0) yfdim=FDIM; /* default filter size */ 
  exp_filt1(xfilt,xfdim,an->xvar);
  exp_filt1(yfilt,yfdim,an->yvar);
  make_nonsep_filt_from_taps(filt,xfilt,yfilt,xfdim,yfdim);

  /**********************************************/
  imsize = cache->imsize;
  
/*
  fprintf(stderr,"xdim=%d ydim=%d imsize=%d\n",
	 cache->xdim, cache->ydim, imsize);
*/
  printf("Enter X-flow \n");
  if((cache_xflow=ask_name_get_cache(image_mgr))==NULL) {
    printf("Error: cannot find xflow sequence\n"); return(-1); }
  
  printf("Enter Y-flow \n");
  if((cache_yflow=ask_name_get_cache(image_mgr))==NULL) {
    printf("Error: cannot find yflow sequence\n"); return(-1); }

  sprintf(yn, "n");
  printf("Do you want to save the interpolated output internally(y/n)? (%s):",yn);
  readline(args,ARGSIZE,stdin);
  if((strlen(args)!=0) && (strcmp(args,"\n")!=0))
    sscanf(args,"%s",yn);
  if(strncmp(yn,"y",1)==0) {
    length = (int)(((float)(end - start))/an->time_step) + 1;
    printf("length of interp. seq. = %d\n", length);
    sprintf(image_mgr->image_name,"%s-interp",cache->image_name);
    if((cache_interp=make_internal_image(image_mgr,cache->xdim,cache->ydim,length
))
       ==NULL) {
      printf("Not saving interpolation results internally.\n");
/*      init_cache(cache_interp); cache_interp=NULL; */
    }
  }
  else
    {
      cache_interp=NULL;
    }

  xdim = cache_xflow->xdim;
  ydim = cache_yflow->ydim;
  /****** input images *****/


  if((array = (unsigned char *)malloc(imsize*sizeof(unsigned char)))==NULL) {
    fprintf(stderr,"cannot allocate memory for array\n"); F_RATE_RET(-1); }
  malloc_images[nmalloc]=(char *)array; nmalloc++;

  if((xflow = (float *)malloc(imsize*sizeof(float)))==NULL) {
    fprintf(stderr,"cannot allocate memory for xflow\n"); F_RATE_RET(-1); }
  malloc_images[nmalloc]=(char *)xflow; nmalloc++;
  
  if((yflow = (float *)malloc(imsize*sizeof(float)))==NULL) {
    fprintf(stderr,"cannot allocate memory for yflow.\n"); F_RATE_RET(-1); }
  malloc_images[nmalloc]=(char *)yflow; nmalloc++;

  if((im1 = (float *)malloc(imsize*sizeof(float)))==NULL) {
    fprintf(stderr,"cannot allocate memory for image.\n"); F_RATE_RET(-1); }
  malloc_images[nmalloc]=(char *)im1; nmalloc++;

  if((im2 = (float *)malloc(imsize*sizeof(float)))==NULL) {
    fprintf(stderr,"cannot allocate memory for image.\n"); F_RATE_RET(-1); }
  malloc_images[nmalloc]=(char *)im2; nmalloc++;

  /***** result images *****/
  if((res = (float *)malloc(imsize*sizeof(float)))==NULL) {
    fprintf(stderr,"cannot allocate memory for result image.\n");
    F_RATE_RET(-1); } 
  malloc_images[nmalloc]=(char *)res; nmalloc++;
   
  if((count = (float *)malloc(imsize*sizeof(float)))==NULL) {
    fprintf(stderr,"cannot allocate memory for count image.\n");
    F_RATE_RET(-1); } 
  malloc_images[nmalloc]=(char *)count; nmalloc++;
  
  /*****************************************/
  
  flowpid=OpenMultiChScreen(ydim,xdim,"interpolated sequence",
			    (float)gamma,(float)1.0,2,nchannels);
  
  fill_im(xflow,(float) 0,imsize); fill_im(yflow,(float) 0,imsize);
/*  printf("file_imsize = %d\n", cache->file_imsize); */
  cur_flow_frame=start-1;
  if ((temp = get_image(cache, cur_flow_frame+1))==NULL){
    printf("error in getting data from internal image\n");
    F_RATE_RET(-1);
  } 
  copy_im(temp,im2,imsize);
  
  /***** begin *************/
  counter = 0;
  for(time=(float)start+toffset;time<=(float)end;
      time+=an->time_step) {
    counter++;
    /* if time exceeds next frame, load the new data */
    while((float)(cur_flow_frame+1)<time) {
      cur_flow_frame++;
      printf("loading data.... time=%5.2f : cur_flow_frame=%d\n",
	     time,cur_flow_frame);
      
      temp=im1;im1=im2;im2=temp; /* advance im2 to first position swap */
      
      if ((temp = get_image(cache_xflow, cur_flow_frame))==NULL){
	printf("error in getting data from internal xflow image\n");
	break;
      }
      copy_im(temp,xflow,imsize);
      if ((temp = get_image(cache_yflow, cur_flow_frame))==NULL){
	printf("error in getting data from internal yflow image\n");
	break;
      }
      copy_im(temp,yflow,imsize);
      if ((temp = get_image(cache, cur_flow_frame+1))==NULL){
	printf("error in getting data from internal image\n");
	break;
      }
      copy_im(temp,im2,imsize);
    }

    fill_im(res,(float)(-1.0),imsize);
    fill_im(count,(float)(0.0),imsize);
    fyscale=an->yscale;  fxscale=an->xscale;
    interp=(float)(time-(float)cur_flow_frame);
    
    if(trunc==1) { int j=((int)(interp+0.5)); interp=(float)j; }

    blah(im1,im2,res,count,nchannels,
	 xflow,yflow,fyscale,fxscale,interp,xdim,ydim,
	 filt,xfdim,yfdim,imethod);
    add_im_sc(res,1.0,res,cimsize); 

    if (cache_interp != NULL){
      if ((temp = get_image(cache_interp, counter-1))==NULL){
	printf("error in getting data from internal image : cache_interp\n");
	break;  
      }
      copy_im(res,temp,imsize);
    }
    
    convert_float_to_byte(res,array,imsize);
    
    for(channel=0,cf=0;channel<nchannels;channel++,cf+=imsize) {
      display_number_uchar_im(array+cf,xdim,ydim,(float) time,
			      (int)5,(int)5,(int)255,(int)0,"%6.2f");
      DumpBufToScreen(array+cf,ydim,xdim,flowpid,imsize); 
    }

  }
    
  /********* clean up **********/
  F_RATE_RET(0);
/*
  free(im1);  free(im2);
  free(res);free(count);free(array);free(xflow);free(yflow);free(array);
*/  
}
  


/*******************************
** the following was copied from:
*** File: interp-by-flow.c
*** Author: John Y. A. Wang
*** Date: May 26 1993.
*** Copyright 1993, Massachusetts Institute of Technology, All Rights Reserved.
***
*** Description: generate interpolated sequence according to flow
***************************************************************/

int bicubic_interp(im,res,ypos,xpos,xdim,ydim)
  float *im,*res,xpos,ypos;
  int xdim,ydim;
{
  register float *im_ptr;	/* accessed 38x in loop */
  register int base;		/* accessed 30x in loop */
  register float frac, temp;	/* accessed 20x in loop */
  register float frac2, frac3;  /* accessed 10x in loop */
  int x_inbounds_1, x_inbounds0, x_inbounds1, x_inbounds2; /* 6x in loop */
  register float x_coeff_1, x_coeff0, x_coeff1, x_coeff2; /* 5x in loop */
  register float res_val;
  register float xbase,ybase;

/*  fprintf(stderr,"(bicubic_interp)"); */
/*  printf("bicubic_interp: (%d %d)\n",ydim,xdim);fflush(stdout); */
/*  memset(res, 0, xdim*ydim*sizeof(float)); */

  xbase = (int)(xpos);
  ybase = (int)(ypos);

  if((((xbase) >= 0) && ((xbase + 0) < xdim)) &&
     (((ybase) >= 0) && ((ybase + 0) < ydim)))
    {
      res_val = 0.0;

      /* Compute X fractional position and base index */
      frac = xpos - xbase;
      frac2 = frac*frac;
      frac3 = frac*frac2;
      base  = xbase - 1;
      im_ptr = im + base;
      
      x_inbounds_1 = ((base >= 0) && (base < xdim))?1:0;
      if (x_inbounds_1) x_coeff_1 = (frac2/2.0 - frac/3.0 - frac3/6.0);
      base++;
      x_inbounds0  = ((base >= 0) && (base < xdim))?1:0;
      if (x_inbounds0)  x_coeff0  = (1.0 - frac/2.0 - frac2 + frac3/2.0);
      base++;
      x_inbounds1  = ((base >= 0) && (base < xdim))?1:0;
      if (x_inbounds1)  x_coeff1 = (frac + frac2/2.0 - frac3/2.0);
      base++;
      x_inbounds2  = ((base >= 0) && (base < xdim))?1:0;
      if (x_inbounds2)  x_coeff2 = (frac3/6.0 - frac/6.0);
      
      /* Compute Y fractional position and base index */
      frac = ypos - ybase;
      frac2 = frac*frac;
      frac3 = frac*frac2;
      base = ybase - 1 ;
      im_ptr += base*xdim;
      
      if ((base >= 0) && (base < ydim)) { /* y_inbounds_1 */
	temp = 0.0;
	if (x_inbounds_1) temp += x_coeff_1 * *im_ptr; im_ptr++;
	if (x_inbounds0)  temp += x_coeff0  * *im_ptr; im_ptr++;
	if (x_inbounds1)  temp += x_coeff1  * *im_ptr; im_ptr++;
	if (x_inbounds2)  temp += x_coeff2  * *im_ptr; im_ptr -= 3;
	res_val += temp * (frac2/2.0 - frac/3.0 - frac3/6.0);
      }
      base++;  im_ptr += xdim;
      if ((base >= 0) && (base < ydim)) { /* y_inbounds0 */
	temp = 0.0;
	if (x_inbounds_1) temp += x_coeff_1 * *im_ptr; im_ptr++;
	if (x_inbounds0)	temp += x_coeff0  * *im_ptr; im_ptr++;
	if (x_inbounds1)	temp += x_coeff1  * *im_ptr; im_ptr++;
	if (x_inbounds2)	temp += x_coeff2  * *im_ptr; im_ptr -= 3;
	res_val += temp * (1 - frac/2.0 - frac2 + frac3/2.0);
      }
      base++;  im_ptr += xdim; 
      if ((base >= 0) && (base < ydim)) { /* y_inbounds1 */
	temp = 0.0;
	if (x_inbounds_1) temp += x_coeff_1 * *im_ptr; im_ptr++;
	if (x_inbounds0)  temp += x_coeff0  * *im_ptr; im_ptr++;
	if (x_inbounds1)  temp += x_coeff1  * *im_ptr; im_ptr++;
	if (x_inbounds2)  temp += x_coeff2  * *im_ptr; im_ptr -= 3;
	res_val += temp * (frac + frac2/2.0 - frac3/2.0);
      }
      base++;  im_ptr += xdim;
      if ((base >= 0) && (base < ydim)) { /* y_inbounds2 */
	temp = 0.0;
	if (x_inbounds_1) temp += x_coeff_1 * *im_ptr; im_ptr++;
	if (x_inbounds0)  temp += x_coeff0  * *im_ptr; im_ptr++;
	if (x_inbounds1)  temp += x_coeff1  * *im_ptr; im_ptr++;
	if (x_inbounds2)  temp += x_coeff2  * *im_ptr; im_ptr -= 3;
	res_val += temp * (frac3/6.0 - frac/6.0);
      }
      *res=(float)res_val;
    } /* end base inbounds */
  else{
    *res=(float)0.0;
  }
}

/***************************************************************/
blah(im1,im2,res,count,nchannels,
     wx,wy,yscale,xscale,interp,xdim,ydim,filt,xfdim,yfdim,imethod)
  float *im1,*im2,*wx,*wy;
  float *res,*count;
  int nchannels,xdim,ydim;
  float xscale,yscale,interp;
  float *filt;
  int xfdim,yfdim;
  int imethod;
{
  int x,y,pos;
  float xpos,ypos;

  float alpha1=(1.0-interp),alpha2=interp;
  
  float *im1c[10],*im2c[10],*resc[10],*countc[10];
  float z,err1,err2,val[10],val1[10],val2[10];
  int ch,cf,imsize=xdim*ydim;
  

/*  fprintf(stderr,"blah: nchannels=%d\n",nchannels);*/

  for(ch=0,cf=0;ch<nchannels;ch++,cf+=imsize) {
    if(im1!=NULL) im1c[ch]=im1+cf; else im1c[ch]=NULL;
    if(im2!=NULL) im2c[ch]=im2+cf; else im2c[ch]=NULL;
    resc[ch]=res+cf; countc[ch]=count+cf;  /* these can't be null */
  }

  /**** degenerate cases. Don't need to interpolate ****/
  if(interp==0 && im1!=NULL) { copy_im(im1,res,nchannels*imsize); return(0); }
  if(interp==1 && im2!=NULL) { copy_im(im2,res,nchannels*imsize); return(0); }

  for(y=0,pos=0;y<ydim;y++) {
    for(x=0;x<xdim;x++,pos++) {
      xpos=x-xscale*wx[pos]; ypos=y-yscale*wy[pos];
      if(im1!=NULL && im2 == NULL) {  /* only the first image available */
	for(ch=0;ch<nchannels;ch++) {
	  bicubic_interp(im1c[ch],&val[ch],ypos,xpos,xdim,ydim);}
      }
      else if(im1==NULL && im2!=NULL) {  /* only the second image avail */
	for(ch=0;ch<nchannels;ch++) { 
	  val[ch]=im2c[ch][pos];}
      }
      else if(im1!=NULL && im2!=NULL) { /* both images available */
	for(ch=0,err1=0,err2=0;ch<nchannels;ch++) {
	  bicubic_interp(im1c[ch],&val[ch],ypos,xpos,xdim,ydim);
	  val2[ch]=im2c[ch][pos]; val1[ch]=im1c[ch][pos];
	  z=(val[ch]-val2[ch]);err1+=z*z;    /* with compensation */
	  z=(val1[ch]-val2[ch]);err2+=z*z;   /* without compenstation */
	}
	if(imethod==0 || err1<err2) {  /* compensation is better */
	  for(ch=0;ch<nchannels;ch++) {
	    val[ch]=alpha1*val[ch] + alpha2*val2[ch]; }
	  xpos=alpha1*xpos+alpha2*x;
	  ypos=alpha1*ypos+alpha2*y;
	}
	else {   /* compensation is not better */
	  for(ch=0;ch<nchannels;ch++) {
	    val[ch]=alpha1*val1[ch] + alpha2*val2[ch]; }
	  xpos=x; ypos=y;  /* use current im2 pos */
	}
      }

      for(ch=0;ch<nchannels;ch++) {
	filt_fill_pt(resc[ch],countc[ch],xdim,ydim,val[ch],
		     xpos,ypos,filt,xfdim,yfdim);
      }
    }}
/*  fprintf(stderr,"div_im\n"); */
  div_im(res,count,res,nchannels*imsize);
  return(0);
}

/***************************************************************/
int filt_fill_pt(im,weight,xdim,ydim,val,xpos,ypos,filt,fxdim,fydim)
  float *im,*weight,val,xpos,ypos,*filt;
  int xdim,ydim,fxdim,fydim;
{

  int xstart=(int)(xpos-(fxdim-1)/2), xend=(int)(xpos+(fxdim+1)/2);
  int ystart=(int)(ypos-(fydim-1)/2), yend=(int)(ypos+(fydim+1)/2);
  float xoff=((fxdim-1)/2 - xpos),  yoff=((fydim-1)/2 - ypos);
  int x,y;
  float fx,fy,fval;
  int yp,pos;

/*  fprintf(stderr,"(filt_fill_pt)");*/
  for(y=ystart,fy=y+yoff,yp=y*xdim;y<yend;y++,fy++,yp+=xdim) {
    for(x=xstart,fx=x+xoff,pos=yp+x;x<xend;x++,fx++,pos++) {
/*      fprintf(stderr,"(%d,%d,%3.1f,%3.1f) ",x,y,fx,fy); */
      if((y>=0 && y<ydim && x>=0 && x<xdim) &&
	 (fy>=0 && fy<fydim && fx>=0 && fx<fxdim) ) {
	bilinear_warp_pt(filt, &fval, fy, fx, fydim , fxdim);
/*	fprintf(stderr,"%3.1f",fval); */
	im[pos]+=val*fval;
	weight[pos]+=fval;
      }
    }}
  return(0);
}

/***************************************************************/
int bilinear_warp_pt(im, res, ypos, xpos, ydim, xdim)
  register float *im, *res, xpos, ypos;
  register int xdim, ydim;
{
  register int ia0, ja0, ia1, ja1;
  register float x, y, xy;


  ia0 = (int)(xpos);  /* (int) doesn't work - breaks for negative nums! */
  ja0 = (int)(ypos);
  if ((ia0 >= 0) && (ja0 >= 0) && (ia0 < xdim-1) && (ja0 < ydim-1)) {
    ja0 *= xdim;
    ja1 = ja0 + xdim;
    ia1 = ia0+1;
    x = xpos - (float)((int) xpos);
    y = ypos - (float)((int) ypos);
    xy = x*y;
      *res = im[ia0+ja0]*(1.0-x-y+xy) + im[ia0+ja1]*(y-xy) + 
	  im[ia1+ja0]*(x-xy) + im[ia1+ja1]*xy;
  }
  else *res = 0.0;
}


/***************************************************************/
int make_nonsep_filt_from_taps(farray,xtaps,ytaps,xfdim,yfdim)
  float *farray,*xtaps,*ytaps;
  int xfdim,yfdim;
{
  int x,y,pos;
  
  for(y=0,pos=0;y<yfdim;y++) {
   for(x=0;x<xfdim;x++,pos++) {
      farray[pos]=xtaps[x]*ytaps[y];
    }}
}

#include<math.h>

/***************************************************************/
exp_filt1(filt,dim,var)
  float *filt;
  float var;
  int dim;
{
  int i;
  float dx=((int)(dim-1)/2)+1;
  double scale;
  
/*  fprintf(stderr,"var=%f\n",var); */
  scale=(double)exp((double)(1/(var*2)));
  for(i=0;i<dim;i++) {
    dx=(i-(dim-1)/2);
    filt[i]=(float)(scale*exp((double)(-(abs_val(dx*dx)/(var*2)))));
  }
}

/***************************************************************/
FILE *OpenMultiChScreen(height,width,text,gamma,zoom,nframes,nchannels)
  int height, width;
  char *text;
  float gamma,zoom;
  int nframes,nchannels;
{
  char ExecRLE[400];

/*  FILE *pid; */

  fprintf(stderr,"in OpenMultiChScreen..........\n");
  if(zoom<1) {
    sprintf(ExecRLE,
	    "rawtorle  -h %d -w %d -n %d -N | rlezoom %f | rleflip -v | getx11 -j -t \"%s\" -i %f %s",
	    height, width, nchannels, zoom, text, gamma, (nframes>1? "-m":" "));
  }
  else {
    sprintf(ExecRLE,
	    "rawtorle  -h %d -w %d -n %d -N | rleflip -v |  rlezoom %f | getx11 -j -t \"%s\" -i %f %s",
	    height, width, nchannels, zoom, text, gamma, (nframes>1? "-m":" "));
  }
  fprintf(stderr,"starting process\n");
  fprintf(stderr,"%s\n",ExecRLE);
  return( popen(ExecRLE,"w"));

}


