/******************************************************************

"Copyright  1994 by the Massachusetts  Institute  of  Technology.  All
rights reserved.

Developed by John Y. A. Wang at the  Media Laboratory, MIT, Cambridge,
Massachusetts, with  support  from Secom Ltd., Goldstar Ltd.,  and the
Television of Tomorrow Program.

For use by authorized users only.

This distribution is approved  by Nicholas Negroponte, Director of the
Media Laboratory, MIT.

Permission to use, copy, or modify this software and its documentation
for educational and research purposes only and without  fee is  hereby
granted, provided that this copyright notice and the original authors'
names  appear  on  all  copies  and   supporting   documentation.   If
individual  files  are  separated  from  this  distribution  directory
structure, this copyright notice must be included.  For any other uses
of  this software, in  original or  modified form, including  but  not
limited to distribution in whole or in part, specific prior permission
must be  obtained  from  MIT.   These  programs  shall  not  be  used,
rewritten,  or  adapted  as  the  basis  of a  commercial software  or
hardware  product without  first  obtaining  appropriate licenses from
MIT.  MIT.  makes no  representations about  the  suitability of  this
software for any purpose.  It is  provided "as is" without  express or
implied warranty.

******************************************************************/


/* 
*	r o b o t . h				dead@media-lab  87/02/27
*
*		Header file for Psuedo-Inverse functions
*
*		Copyright (c) 1987 by David T. Chen. 
*		All rights reserved.
*/

/*  #define MAX_RANK (100)     /* tjd 5/6/89 -- watch out for csh limit stacksize */

#define MAX_RANK		(30)

#define MAX_IMPROVE		(32)
#define SINGULAR		(-1)
#define NOT_SINGULAR	        (0)
#define LAST_JOINT		(-1)
#define NEW_HEAD		(-2)
#define FORWARD			(1)
#define BACKWARD		(0)

typedef float RobotType;  /* used to be double */


/*
*	MatrixType definitions
*/
typedef struct
{	int n, m;
	RobotType data[ MAX_RANK ][ MAX_RANK ];
} MatrixType;

/* same thing, without full size matrix decl. */
typedef struct
{	int n, m;
	RobotType (*data) [ MAX_RANK ];
} PMatrixType;

typedef RobotType  (*MatrixData)[ MAX_RANK ]; 

#define MatrixType_Get_N(matrix)	((matrix)->n)
#define MatrixType_Get_M(matrix)	((matrix)->m)
#define MatrixType_Get_Data(matrix)	((matrix)->data)


/*
*	VectorType definitions
*/
typedef struct
{	int n;
	RobotType data[ MAX_RANK ];
} VectorType;

typedef RobotType *VectorData;

#define VectorType_Get_N(vector)	((vector)->n)
#define VectorType_Get_Data(vector)	((vector)->data)


/*
*	IndexType definitions
*/
typedef struct
{	int n;
	int data[ MAX_RANK ];
} IndexType;

typedef int *IndexData;

#define IndexType_Get_N(index)		((index)->n)
#define IndexType_Get_Data(index)	((index)->data)


/*
*	Function definitions
*/
#define MatrixType_Printf(matrix)	MatrixType_Fprintf(stdout,(matrix))
#define VectorType_Printf(vector)	VectorType_Fprintf(stdout,(vector))

#define PINSG(x,j,r)	PseudoInverseNoSecondaryGoals((x),(j),(r))
#define PISG(x,j,r)		PseudoInverseSecondaryGoals((x),(j),(r))
#define abs_robot(x)	(((x)>0.0)?(x):(-(x)))


