/******************************************************************

"Copyright  1994 by the Massachusetts  Institute  of  Technology.  All
rights reserved.

Developed by John Y. A. Wang at the  Media Laboratory, MIT, Cambridge,
Massachusetts, with  support  from Secom Ltd., Goldstar Ltd.,  and the
Television of Tomorrow Program.

For use by authorized users only.

This distribution is approved  by Nicholas Negroponte, Director of the
Media Laboratory, MIT.

Permission to use, copy, or modify this software and its documentation
for educational and research purposes only and without  fee is  hereby
granted, provided that this copyright notice and the original authors'
names  appear  on  all  copies  and   supporting   documentation.   If
individual  files  are  separated  from  this  distribution  directory
structure, this copyright notice must be included.  For any other uses
of  this software, in  original or  modified form, including  but  not
limited to distribution in whole or in part, specific prior permission
must be  obtained  from  MIT.   These  programs  shall  not  be  used,
rewritten,  or  adapted  as  the  basis  of a  commercial software  or
hardware  product without  first  obtaining  appropriate licenses from
MIT.  MIT.  makes no  representations about  the  suitability of  this
software for any purpose.  It is  provided "as is" without  express or
implied warranty.

******************************************************************/


/***************************************************************
*** File: pyramid.h
*** Author: John Y. A. Wang
*** Date: November 18, 1992.
*** Copyright 1992, Massachusetts Institute of Technology, All Rights Reserved.
***
*** Description: header file for pyramid.c 
***      pyramid structure declarations.
***      These routines are part of the DYNAMO software.
***************************************************************/

#ifndef DYNAMO_PYRAMID_INCLUDED
#define DYNAMO_PYRAMID_INCLUDED

static  char *copyright_pyr="\
\n\n***********************************************\n\
File: pyramid.h\n\
Author: John Y. A. Wang.\n\
The MIT Media Lab.\n\
Copyright (c) 1992, All Rights Reserved.\n\
***********************************************\n\n";


#define PYRMAXLEVEL 10

/* Image structure */
struct Image {
  int xdim;
  int ydim;
  float *array;  /* pointer to image array */
};
typedef struct Image Image;

/* Pyramid structure */
struct Pyramid {
  int levels;
  Image level[PYRMAXLEVEL+1]; /* array of image structures */
};
typedef struct Pyramid Pyramid;


#endif
